// avoid old Seg
var _Seg = Seg;
var Seg = {};
var fs = require('fs');
var stream = null;
var stream = require('stream');

module.exports = Json_segment;

function Json_segment (json, seg, encoding, cb) {
	if(!(json instanceof stream.Readable)) {
		if(Seg.parseJson(json) || json instanceof Object) {
			// this is a raw json
			if(arguments.length > 3) {
				console.error("too many arguments");
			}else if (arguments.length === 3) {
				cb = encoding;
				encoding = null;

				Seg._raw(json, seg, function() {
					cb(null, Seg.json_arr);	
				});	
			}else if (arguments.length < 3) {
				console.error("should at least 3 arguments")
			}else {
				console.error("arguments too few.")
			}
		}else {
			console.error('should input a json or json string or node stream object.')
		}
	}else {
		// streaming
		if(arguments.length < 3) {
			console.error('Not enough arguments.')
		}if(arguments.length === 3) {
			// no setting encoding
			cb = encoding;
			stream = json;
			encoding = null;

			Seg._stream(stream, seg, encoding, function() {
				cb(null, Seg.json_arr)
			});
		}else if(arguments.length === 4) {
			encoding = encoding || 'utf8';

			Seg._stream(stream, seg, encoding, function() {
				cb(null, Seg.json_arr)
			});
		}else {
			console.error('Argument wrong.')
		}
	}
	
}


Seg._stream = function(stream, seg, encoding, cb) {
	stream.setEncoding(encoding);
	this.json_arr = [];
	var that = this;
	// streaming fs
	var fs_str = '';
	stream.on('data', function(chunk) {
		fs_str += chunk;
	})
	stream.on('end', function() {
		var parse = JSON.parse(fs_str);
		if(!isNaN(seg)) {
			var total = that.total(parse);
			var seg_count = Math.ceil(total / seg);
			that.seg_count = seg_count;
			that.segment(parse, total, function() {
				cb();
			});
		}else {
			var key_arr = []
			for(var i = 0; i < parse.length; i++) {
				if(key_arr.indexOf(parse[i][seg]) !== -1) {
					// exist in key array
					var num = key_arr.indexOf(parse[i][seg]);
					that.json_arr[num].push(parse[i]);
				}else {
					// not exist in key array
					key_arr.push(parse[i][seg]);
					var sub_arr = [];
					sub_arr.push(parse[i]);
					that.json_arr.push(sub_arr);
				}
			}
			cb();
		}
	})
	
}

Seg._raw = function(json_file, seg, cb) {
	this.json_arr = [];
	var that = this;
	// this is a raw json
	if(json_file instanceof Object) {
		var parse = json_file;
	}else {
		var parse = JSON.parse(json_file);
	}
	
	if(!isNaN(seg)) {
		// it is a number
		var total = this.total(parse);
		var seg_count = Math.ceil(total / seg);
		this.seg_count = seg_count;
		this.segment(parse, total, function() {
			cb();
		});
	}else {
		var key_arr = []
		for(var i = 0; i < parse.length; i++) {
			if(key_arr.indexOf(parse[i][seg]) !== -1) {
				// exist in key array
				var num = key_arr.indexOf(parse[i][seg]);
				that.json_arr[num].push(parse[i]);
			}else {
				// not exist in key array
				key_arr.push(parse[i][seg]);
				var sub_arr = [];
				sub_arr.push(parse[i]);
				that.json_arr.push(sub_arr);
			}
		}
		cb();
	}
}

Seg.segment = function(arr, total, cb) {
	var count = 0;
	var seg_arr = [];

	for(var i = 0; i < total; i++) {
		seg_arr.push(arr[i]);
		count++;
		if(count % this.seg_count == 0) {
			this.json_arr.push(seg_arr);
			seg_arr = [];
		}else if(count == total) {
			this.json_arr.push(seg_arr);
		}
	}
	cb();
}

Seg.parseJson = function(str) {
	try{
		JSON.parse(str)
	}catch(e) {
		return false;
	}
	return true;
}

Seg.total = function(json) {
	return json.length;
}
